local TN_TargetName
local TN_TargetNote
local TN_MouseoverName
local TN_InputName

local TN_CommandUsed = 0
local TN_DropdownClicked = 0

local Login_EventFrame = CreateFrame("Frame")
Login_EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
Login_EventFrame:SetScript("OnEvent",
	function(self, event, ...)
	
			--parent box
			local f=TN_InputBox or CreateFrame("Frame","TN_InputBox",UIParent)
			f:SetSize(255,70)
			f:SetPoint("CENTER", 0, 100);
			f:SetBackdrop({
							bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark",
							edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
							tile = true,
							tileSize = 32,
							edgeSize = 32,
							insets = { left = 11, right = 11, top = 11, bottom = 11 }
						});
			tinsert(UISpecialFrames,"TN_InputBox");

			--input box for the character name
			f=TN_NameBox or CreateFrame("EditBox","TN_NameBox",TN_InputBox,"InputBoxTemplate")
			f:SetSize(180,24)
			f:SetPoint("CENTER", "TN_InputBox", 20, 11);
			f:SetAutoFocus(false)
			f:SetScript("OnEnterPressed",function(s)
						TN_InputName = (s:GetText())
						TN_NoteBox:SetFocus()
						--print("Enter was pressed in NameBox")
					end)
			f:SetScript("OnShow", function(s)
						--print("Nameboxshow")
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						if TN_TargetName == nil then
							TN_NameBox:SetFocus()
							--print("NameBox was shown and TargetName was empty")
						end
						if TN_CommandUsed == 1 or TN_DropdownClicked == 1 then
							TN_NameBox:SetText("")
							TN_NameBox:Insert(TN_TargetName)
							TN_InputName = TN_TargetName
							TN_CommandUsed = 0
							TN_DropdownClicked =0
						end
						TN_CommandUsed = 0
						TN_DropdownClicked =0
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
					end)
			f:SetScript("OnEditFocusLost", function(s)
						--print("Nameboxfocuslost")
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						TN_InputName = (s:GetText())
						TN_CommandUsed = 0
						TN_DropdownClicked = 0
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						--print("Focus was lost from NameBox")
					end)
			f:SetScript("OnEditFocusGained", function(s)
						--print("Nameboxfocus")
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						if TN_CommandUsed == 1 or TN_DropdownClicked == 1 then
							TN_NameBox:SetText("")
							TN_NameBox:Insert(TN_TargetName)
							TN_InputName = TN_TargetName
							--print("teste123")
							TN_CommandUsed = 0
							TN_DropdownClicked = 0
						end
						TN_CommandUsed = 0
						TN_DropdownClicked =0
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
					end)
			f:CreateFontString("TN_NameText", OVERLAY, "GameFontNormal")
			TN_NameText:SetPoint("CENTER", "TN_NameBox", -115, 0);
			TN_NameText:SetText("Name:")

			--Input box for the note
			f=TN_NoteBox or CreateFrame("EditBox","TN_NoteBox",TN_InputBox,"InputBoxTemplate")
			f:SetSize(180,24)
			f:SetPoint("CENTER", "TN_InputBox", 20, -11);
			f:SetAutoFocus(false)
			f:SetScript("OnEnterPressed",function(s)
						--print(s:GetText())
						TN_TargetNote = (s:GetText())
						if TN_InputName ~= "" then
						TN_Database[TN_InputName] = TN_TargetNote
						TN_InputBox:Hide()
						--print("Enter was pressed in NoteBox")
						UIErrorsFrame:AddMessage("Note Saved", 255, 209, 0)
						else
						TN_NameBox:SetFocus()
						end
					end)
			f:SetScript("OnShow", function(s)
						--print("Noteboxshow")
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						TN_NoteBox:SetText("")
						if TN_TargetName ~= nil then
							TN_NoteBox:SetFocus()
							--print("NoteBox was shown and TargetName was not empty")
						end
						if TN_CommandUsed == 1 or TN_DropdownClicked == 1 then
								TN_NoteBox:SetText("")
								TN_NoteBox:Insert(TN_Database[TN_TargetName])
								TN_CommandUsed = 0
								TN_DropdownClicked = 0
								print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						end
						TN_CommandUsed = 0
						TN_DropdownClicked =0
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
					end)
			f:SetScript("OnEditFocusGained", function(s)
						--print("Noteboxfocus")
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
						TN_TargetNote = (s:GetText())
						--print(TN_TargetNote)
						if TN_InputName == nil then
							TN_NoteBox:SetText("")
							--print("NoteBox gained focus and TargetName was empty")
						end
						if TN_TargetNote == "" then
							if TN_Database[TN_InputName] then
								TN_NoteBox:SetText("")
								TN_NoteBox:Insert(TN_Database[TN_InputName])
							end
						end
						if TN_Database[TN_InputName] then
							if TN_CommandUsed == 1 or TN_DropdownClicked == 1 then
								TN_NoteBox:SetText("")
								TN_NoteBox:Insert(TN_Database[TN_InputName])
								TN_CommandUsed = 0
								TN_DropdownClicked = 0
								--print(TN_CommandUsed)
								--print(TN_DropdownClicked)
							end
							--print("NoteBox gained focus and targetname was found in database")
						end
						TN_CommandUsed = 0
						TN_DropdownClicked = 0
						--print(TN_CommandUsed)
						--print(TN_DropdownClicked)
					end)
			f:CreateFontString("TN_NoteText", OVERLAY, "GameFontNormal")
			TN_NoteText:SetPoint("CENTER", "TN_NoteBox", -113, 0);
			TN_NoteText:SetText("Note:")
			
			TN_InputBox:Hide()
end)

SLASH_TN_Commands1 = "/tn"
SlashCmdList["TN_Commands"] = function(msg)
	TN_TargetName = UnitName("target")
	TN_CommandUsed = 1
	--print("teste333")
	--print(TN_CommandUsed)
	--print(TN_DropdownClicked)
	if TN_TargetName ~= nil then
		TN_NameBox:SetText("")
		TN_NameBox:SetText(TN_TargetName)
		--print("command executed and TargetName was not empty")
		if TN_Database[TN_TargetName] then
			TN_NoteBox:SetText("")
			TN_NoteBox:SetText(TN_Database[TN_TargetName])
		else
			TN_NoteBox:SetText("")
			--print("command executed and TargetName was found in database")
		end
	end
	TN_InputBox:Show()
end

local function testDropdownMenuButton(self)
	if self.value == "TN_MenuButton" then
		TN_DropdownClicked = 1
		--print("clicked1") 
		TN_InputBox:Show()
		TN_NameBox:SetText("")
		TN_NameBox:Insert(TN_TargetName)
		TN_NoteBox:SetText("")
		TN_NoteBox:Insert(TN_Database[TN_TargetName])
		--print("teste222")
		--print(TN_CommandUsed)
		--print(TN_DropdownClicked)
	end
end

hooksecurefunc("UnitPopup_ShowMenu", function(dropdownMenu, which, unit, name, userData)

TN_TargetName = UnitName(unit)
--print("got name from right-click")
	if (UIDROPDOWNMENU_MENU_LEVEL > 1) then
	return
	end
		local info = UIDropDownMenu_CreateInfo()
			info.text = "Edit Tooltip Note"
			info.owner = which
			info.notCheckable = 1
			info.func = testDropdownMenuButton 
			info.value = "TN_MenuButton"
			UIDropDownMenu_AddButton(info)
end)

GameTooltip:HookScript("OnTooltipSetUnit", function(self)
  local _, unit = self:GetUnit()
  if UnitExists(unit) then
    TN_MouseoverName = UnitName(unit)
    if TN_Database[TN_MouseoverName] and TN_Database[TN_MouseoverName] ~= "" then
        GameTooltip:AddLine('"' .. TN_Database[TN_MouseoverName] .. '"', 255, 209, 0)
        GameTooltip:Show()
    end
  end
end)

local Addon_EventFrame = CreateFrame("Frame")
Addon_EventFrame:RegisterEvent("ADDON_LOADED")
Addon_EventFrame:SetScript("OnEvent",
	function(self, event, addon)
		if addon == "TooltipNotes" then
			TN_Database = TN_Database or {}
		end
end)